//
//  LivePusherTool.h
//  livepush
//
//  Created by ISS013602000846 on 2023/3/15.
//

#import <UIKit/UIKit.h>

extern NSString *LiveBaseMethodName;
extern NSString *LiveBaseEventName;
extern NSString *LivePusherMethodName;
extern NSString *LivePusherEventName;
extern NSString *LivePusherPreviewName;
extern NSString *LivePusherConfigMethodName;

extern NSString *LivePusherEventChannelDefMethod;
extern NSString *LivePusherEventChannelDefLicenceCheckResult;
extern NSString *LivePusherEventChannelDefLicenceCheckReason;
extern NSString *LivePusherEventChannelDefErrorCode;
extern NSString *LivePusherEventChannelDefErrorDescription;
extern NSString *LivePusherEventChannelDefBGMProgress;
extern NSString *LivePusherEventChannelDefBGMDuration;
extern NSString *LivePusherEventChannelDefSnapShotSaveResult;
extern NSString *LivePusherEventChannelDefSnapShotSavePath;

typedef NS_ENUM(NSInteger, LivePusherSaveDirType) {
    // NSDocumentDirectory
    LivePusherSaveDirTypeDocument = 0,
    // NSLibraryDirectory
    LivePusherSaveDirTypeLibrary,
    // NSCachesDirectory
    LivePusherSaveDirTypeCaches,
};

NS_ASSUME_NONNULL_BEGIN

@interface LivePusherTool : NSObject

+ (NSString *)saveDir:(LivePusherSaveDirType)dirType dir:(NSString *)dir;
+ (NSString *)getResourceSavePath:(LivePusherSaveDirType)dirType dir:(NSString *)dir;
+ (NSString *)randomString;
+ (NSString *)getCurrentDateString;
+ (UIImage *)getImageWithContent:(NSString *)imageName;

@end

NS_ASSUME_NONNULL_END
