//
//  LivePusherTool.m
//  livepush
//
//  Created by ISS013602000846 on 2023/3/15.
//

#import "LivePusherTool.h"

NSString *LiveBaseMethodName = @"plugins.livebase.method";
NSString *LiveBaseEventName = @"plugins.livebase.event";
NSString *LivePusherMethodName = @"plugins.livepush.pusher.method";
NSString *LivePusherEventName = @"plugins.livepush.pusher.event";
NSString *LivePusherPreviewName = @"plugins.livepush.preview";
NSString *LivePusherConfigMethodName = @"plugins.livepush.pushConfig.method";

NSString *LivePusherEventChannelDefMethod = @"method";
NSString *LivePusherEventChannelDefLicenceCheckResult = @"result";
NSString *LivePusherEventChannelDefLicenceCheckReason = @"reason";
NSString *LivePusherEventChannelDefErrorCode = @"errorCode";
NSString *LivePusherEventChannelDefErrorDescription = @"errorDescription";
NSString *LivePusherEventChannelDefBGMProgress = @"progress";
NSString *LivePusherEventChannelDefBGMDuration = @"duration";
NSString *LivePusherEventChannelDefSnapShotSaveResult = @"saveResult";
NSString *LivePusherEventChannelDefSnapShotSavePath = @"savePath";

@implementation LivePusherTool

+ (NSString *)saveDir:(LivePusherSaveDirType)dirType dir:(NSString *)dir {
    NSString *baseDirPath = @"";
    if (dirType == LivePusherSaveDirTypeDocument) {
        baseDirPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) firstObject];
    } else if (dirType == LivePusherSaveDirTypeLibrary) {
        baseDirPath = [NSSearchPathForDirectoriesInDomains(NSLibraryDirectory, NSUserDomainMask, YES) firstObject];
    } else {
        baseDirPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
    }
    
    if (dir.length == 0) {
        return baseDirPath;
    }
    
    baseDirPath = [baseDirPath stringByAppendingPathComponent:dir];
    NSFileManager *manager = [NSFileManager defaultManager];
    BOOL isDir;
    NSError *error;
    if (![manager fileExistsAtPath:baseDirPath isDirectory:&isDir]) {
        BOOL success = [manager createDirectoryAtPath:baseDirPath withIntermediateDirectories:YES attributes:nil error:&error];
        if (!success || error) {
            baseDirPath = @"";
            NSLog(@"文件保存地址创建失败");
        }
    }
    return baseDirPath;
}

+ (NSString *)randomString {
    CFUUIDRef puuid = CFUUIDCreate(nil);
    CFStringRef uuidString = CFUUIDCreateString(nil, puuid);
    NSString * result = (NSString *)CFBridgingRelease(CFStringCreateCopy(nil, uuidString));
    CFRelease(puuid);
    CFRelease(uuidString);
    return result;
}

+ (NSString *)getCurrentDateString {
    NSDate *currentDate = [NSDate date];//获取当前时间，日期
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"YYYY-MM-dd-hh-mm-ss-SS"];
    NSString *dateString = [dateFormatter stringFromDate:currentDate];
    return dateString;
}

+ (UIImage *)getImageWithContent:(NSString *)imagePath {
    UIImage *image = nil;
    if (imagePath && imagePath.length > 0) {
        image = [UIImage imageWithContentsOfFile:imagePath];
    }
    return image;
}

+ (NSString *)getResourceSavePath:(LivePusherSaveDirType)dirType dir:(NSString *)dir {
    NSString *dirPath = @"";
    if (dirType == LivePusherSaveDirTypeDocument) {
        dirPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) firstObject];
    } else if (dirType == LivePusherSaveDirTypeLibrary) {
        dirPath = [NSSearchPathForDirectoriesInDomains(NSLibraryDirectory, NSUserDomainMask, YES) firstObject];
    } else {
        dirPath = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
    }
    dirPath = [dirPath stringByAppendingPathComponent:dir];
    return dirPath;
}

@end
